<template>
   <div>
      <div id="exampleModal" class="modal fade" tabindex="-1" aria-labelledby="exampleModalLabel" aria-hidden="true">
         <div class="modal-dialog">
            <div class="modal-content">
               <div class="modal-header">
                  <div>
                     <h5 id="exampleModalLabel" class="modal-title text-center">
                        Wklej plik CSV aby skonwertować go na jsona
                     </h5>
                     <div v-if="emptyJson" class="text-danger font-weight-bold">
                        Błąd konwersji, podałeś zły format pliku
                     </div>
                  </div>
                  <button
                     type="button"
                     class="btn-close"
                     data-bs-dismiss="modal"
                     aria-label="Close"
                     @click="
                        () => {
                           emptyJson = false
                        }
                     "
                  ></button>
               </div>
               <div class="modal-body">
                  <textarea id="message-text" v-model="csvValue" class="form-control"></textarea>
               </div>
               <div class="modal-footer">
                  <button type="button" class="btn btn-primary" @click="convert(csvValue)">Dodaj Rezerwacje</button>
               </div>
            </div>
         </div>
      </div>
   </div>
</template>

<script setup lang="ts">
import { csvJSON } from "@/utils/JsonParser"
import { ref, onMounted } from "vue"
import { Modal } from "bootstrap"

const csvValue = ref<string>(""),
   emptyJson = ref<boolean>(false),
   modalInstance = ref<Modal | null>(null)

function convert(csv: string) {
   const jsonValue: any = csvJSON(csv)
   console.log(jsonValue)
   if (jsonValue != "") {
      const blob = new Blob([JSON.stringify(jsonValue, null, 2)], { type: "application/json" })
      const link = document.createElement("a")
      link.href = URL.createObjectURL(blob)
      link.download = "data.json"

      document.body.appendChild(link)

      link.click()

      document.body.removeChild(link)
      emptyJson.value = false
   } else {
      emptyJson.value = true
   }
}

function openModal() {
   if (modalInstance.value) {
      modalInstance.value.show()
   }
}

function handleKeydown(event: KeyboardEvent) {
   if (event.ctrlKey && event.key === "i") {
      openModal()
   }
}

onMounted(() => {
   const modalElement = document.getElementById("exampleModal")
   if (modalElement) {
      modalInstance.value = new Modal(modalElement)
   }
   window.addEventListener("keydown", handleKeydown)
})
</script>
